************************************************************************
* File (bbbb_ha_11_11.f) created on Thu Nov 19 18:34:35 MSK 2009.
************************************************************************
* This is the FORTRAN module (bbbb_ha_11_11) to calculate EW
* cross-section (width) by using the helicity amplitudes
* for the a + a -> a + a process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2009.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine bbbb_ha_11_11 (s,t,u,sigma)
      implicit none!
#include "s2n_declare_r16.h"

      integer i,j,k,l,ii,jj
      real*16 sum,nsig,ewcoeff,qedcoeff,awc,rts,rus
      complex*32 b0fqsww,b0ftsww,b0fusww
      complex*32 c0ccqswww,c0cctswww,c0ccuswww
      complex*32 d0ccccqstswwww,d0ccccqsuswwww,d0ccccustswwww
      complex*32 b0fqsff,b0ftsff,b0fusff
      complex*32 c0ccqsfff,c0cctsfff,c0ccusfff,d0404m
      complex*32 d0ccccqstsffff,d0ccccqsusffff,d0ccccustsffff
      complex*32 ewamp(2,2,2,2),qedamp(2,2,2,2)
      real*16 mgen2,mars(9),cqfa(9),cqfactor
      complex*32 mgen2i,marsi(9)
      common /awc/awc

      rts=-t/s
      rus=-u/s
      if(rts.lt.awc) then
        t=-s*awc
        u=-s-t
      endif
      if(rus.lt.awc) then
        u=-s*awc
        t=-s-u
      endif

      mars(1)   = relm2
      marsi(1)  = elm2
      cqfa(1)   = qel**4
      mars(2)   = rupm2
      marsi(2)  = upm2
      cqfa(2)   = 3q0*qup**4
      mars(3)   = rdnm2
      marsi(3)  = dnm2
      cqfa(3)   = 3q0*qdn**4
      mars(4)   = rmom2
      marsi(4)  = mom2
      cqfa(4)   = qmo**4
      mars(5)   = rchm2
      marsi(5)  = chm2
      cqfa(5)   = 3q0*qch**4
      mars(6)   = rstm2
      marsi(6)  = stm2
      cqfa(6)   = 3q0*qst**4
      mars(7)   = rtam2
      marsi(7)  = tam2
      cqfa(7)   = qta**4
      mars(8)   = rtpm2
      marsi(8)  = tpm2
      cqfa(8)   = 3q0*qtp**4
      mars(9)   = rbtm2
      marsi(9)  = btm2
      cqfa(9)   = 3q0*qbt**4

      nsig=1000q0*conhc/128/pi/s ! pb goes to fb
      ewcoeff = -12q0*alpha**2
      qedcoeff = 8q0*alpha**2

***************************
*  EW helicity amplitudes *
***************************

      ewamp(1,1,1,1) = 0q0
      ewamp(1,1,1,2) = 0q0
      ewamp(1,1,2,2) = 0q0
      ewamp(1,2,1,2) = 0q0
      ewamp(1,2,2,1) = 0q0

      if (iew.eq.1) then

      b0fqsww = b0f(s,wm2)
      b0ftsww = b0f(t,wm2)
      b0fusww = b0f(u,wm2)
      c0ccqswww = -c01(0q0,0q0,-s,wm2,wm2,wm2)
      c0cctswww = -c01(0q0,0q0,-t,wm2,wm2,wm2)
      c0ccuswww = -c01(0q0,0q0,-u,wm2,wm2,wm2)
      d0ccccqstswwww = d0404M(s,t,wm2)
      d0ccccqsuswwww = d0404M(s,u,wm2)
      d0ccccustswwww = d0404M(u,t,wm2)
 
      ewamp(1,1,2,2) = 
     & +1q0-2q0*rwm2**2*(d0ccccqstswwww+d0ccccqsuswwww+d0ccccustswwww)

      ewamp(1,1,1,2) = 
     & +1q0-rwm2*(s**2+t**2+u**2)*( 1q0/u/t*c0ccqswww
     &                             +1q0/s/u*c0cctswww
     &                             +1q0/s/t*c0ccuswww)
     & -rwm2*((2q0*rwm2+s*t/u)*d0ccccqstswwww
     &       +(2q0*rwm2+s*u/t)*d0ccccqsuswwww
     &       +(2q0*rwm2+t*u/s)*d0ccccustswwww)

      ewamp(1,1,1,1) = 
     & -1q0+(u-t)/s*(b0fusww-b0ftsww)
     & +(4q0*rwm2/s+2q0*(t*u/s**2-4q0/3))*(u*c0ccuswww+t*c0cctswww)
     & -(2q0*rwm2*s*(rwm2/s-4q0/3)+2q0/3*s**2)*
     &                        ( d0ccccqstswwww
     &                         +d0ccccqsuswwww
     &                         +d0ccccustswwww )
     & -t*u*(4q0*rwm2/s+t*u/s**2-4q0/3)*d0ccccustswwww

      ewamp(1,2,2,1) = 
     & -1q0+(s-t)/u*(b0fqsww-b0ftsww)
     & +(4q0*rwm2/u+2q0*(t*s/u**2-4q0/3))*(s*c0ccqswww+t*c0cctswww)
     & -(2q0*rwm2*u*(rwm2/u-4q0/3)+2q0/3*u**2)*
     &                        ( d0ccccqstswwww
     &                         +d0ccccqsuswwww
     &                         +d0ccccustswwww )
     & -t*s*(4q0*rwm2/u+t*s/u**2-4q0/3)*d0ccccqstswwww

      ewamp(1,2,1,2) = 
     & -1q0+(u-s)/t*(b0fusww-b0fqsww)
     & +(4q0*rwm2/t+2q0*(s*u/t**2-4q0/3))*(u*c0ccuswww+s*c0ccqswww)
     & -(2q0*rwm2*t*(rwm2/t-4q0/3)+2q0/3*t**2)*
     &                        ( d0ccccqstswwww
     &                         +d0ccccqsuswwww
     &                         +d0ccccustswwww )
     & -s*u*(4q0*rwm2/t+s*u/t**2-4q0/3)*d0ccccqsuswwww

      endif

      ewamp(1,1,2,1) = ewamp(1,1,1,2)
      ewamp(1,2,1,1) = ewamp(1,1,1,2)
      ewamp(1,2,2,2) = ewamp(1,1,1,2)
      ewamp(2,1,1,1) = ewamp(1,2,2,2)
      ewamp(2,1,1,2) = ewamp(1,2,2,1)
      ewamp(2,1,2,1) = ewamp(1,2,1,2)
      ewamp(2,1,2,2) = ewamp(1,2,1,1)
      ewamp(2,2,1,1) = ewamp(1,1,2,2)
      ewamp(2,2,1,2) = ewamp(1,1,2,1)
      ewamp(2,2,2,1) = ewamp(1,1,1,2)
      ewamp(2,2,2,2) = ewamp(1,1,1,1)

***************************
* QED helicity amplitudes *
***************************

      qedamp(1,1,1,1) = 0q0
      qedamp(1,1,1,2) = 0q0
      qedamp(1,1,2,2) = 0q0
      qedamp(1,2,1,2) = 0q0
      qedamp(1,2,2,1) = 0q0

      if (iqed.eq.1) then
      do i=1,9 ! number of fermion loop particles

      mgen2 = mars(i)
      mgen2i = marsi(i)
      cqfactor = cqfa(i)
      
      if (mgen2.eq.0) then

      qedamp(1,1,2,2) = qedamp(1,1,2,2) + cqfactor

      qedamp(1,1,1,2) = qedamp(1,1,1,2) + cqfactor

      qedamp(1,1,1,1) = qedamp(1,1,1,1) + cqfactor*(
     d -1q0 + (t-u)/s*(LOG(-u/s) - LOG(-t/s))
     & -(1q0/2 - u*t/s**2)*((LOG(-u/s)-LOG(-t/s))**2 + pi**2))

      qedamp(1,2,2,1) = qedamp(1,2,2,1) + cqfactor*(
     & -1q0 - i_*pi*(t-s)/u
     & -((1q0 + i_*pi)*(t-s)/u + 2q0*i_*pi*(t/u)**2)*LOG(-t/s)
     & -(1q0/2 - s*t/u**2)*LOG(-t/s)**2)

      qedamp(1,2,1,2) = qedamp(1,2,1,2) + cqfactor*(
     & -1q0 - i_*pi*(u-s)/t
     & -((1q0 + i_*pi)*(u-s)/t + 2q0*i_*pi*(u/t)**2)*LOG(-u/s)
     & -(1q0/2 - s*u/t**2)*LOG(-u/s)**2) 

      else

      b0fqsff = b0f(s,mgen2i)
      b0ftsff = b0f(t,mgen2i)
      b0fusff = b0f(u,mgen2i)
      c0ccqsfff = -c01(0q0,0q0,-s,mgen2i,mgen2i,mgen2i)
      c0cctsfff = -c01(0q0,0q0,-t,mgen2i,mgen2i,mgen2i)
      c0ccusfff = -c01(0q0,0q0,-u,mgen2i,mgen2i,mgen2i)
      d0ccccqstsffff = d0404M(s,t,mgen2i)
      d0ccccqsusffff = d0404M(s,u,mgen2i)
      d0ccccustsffff = d0404M(u,t,mgen2i)
 
      qedamp(1,1,2,2) = qedamp(1,1,2,2) + cqfactor*(
     & +1q0-2q0*mgen2**2*(d0ccccqstsffff+d0ccccqsusffff+d0ccccustsffff))

      qedamp(1,1,1,2) = qedamp(1,1,1,2) + cqfactor*(
     & +1q0-mgen2*(s**2+t**2+u**2)*(c0ccqsfff/u/t
     &                              +c0cctsfff/s/u+c0ccusfff/s/t)
     & -mgen2*((2q0*mgen2+s*t/u)*d0ccccqstsffff
     &         +(2q0*mgen2+s*u/t)*d0ccccqsusffff
     &         +(2q0*mgen2+t*u/s)*d0ccccustsffff))

      qedamp(1,1,1,1) = qedamp(1,1,1,1) + cqfactor*(
     d -1q0+(u-t)/s*(b0fusff-b0ftsff)
     & +(4q0*mgen2/s+2q0*(t*u/s**2-1q0/2))*(u*c0ccusfff+t*c0cctsfff)
     & -2q0*mgen2*s*(mgen2/s-1q0/2)*(d0ccccqstsffff
     &                               +d0ccccqsusffff+d0ccccustsffff)
     & -t*u*(4q0*mgen2/s+t*u/s**2-1q0/2)*d0ccccustsffff)

      qedamp(1,2,2,1) = qedamp(1,2,2,1) + cqfactor*(
     & -1q0+(s-t)/u*(b0fqsff-b0ftsff)
     & +(4q0*mgen2/u+2q0*(t*s/u**2-1q0/2))*(s*c0ccqsfff+t*c0cctsfff)
     & -2q0*mgen2*u*(mgen2/u-1q0/2)*(d0ccccqstsffff
     &                        +d0ccccqsusffff+d0ccccustsffff)
     & -t*s*(4q0*mgen2/u+t*s/u**2-1q0/2)*d0ccccqstsffff)

      qedamp(1,2,1,2) = qedamp(1,2,1,2) + cqfactor*(
     & -1q0+(u-s)/t*(b0fusff-b0fqsff)
     & +(4q0*mgen2/t+2q0*(s*u/t**2-1q0/2))*(u*c0ccusfff+s*c0ccqsfff)
     & -2q0*mgen2*t*(mgen2/t-1q0/2)*(d0ccccqstsffff
     &                        +d0ccccqsusffff+d0ccccustsffff)
     & -s*u*(4q0*mgen2/t+s*u/t**2-1q0/2)*d0ccccqsusffff)

      endif
      enddo
      endif

      qedamp(1,1,2,1) = qedamp(1,1,1,2)
      qedamp(1,2,1,1) = qedamp(1,1,1,2)
      qedamp(1,2,2,2) = qedamp(1,1,1,2)
      qedamp(2,1,1,1) = qedamp(1,2,2,2)
      qedamp(2,1,1,2) = qedamp(1,2,2,1)
      qedamp(2,1,2,1) = qedamp(1,2,1,2)
      qedamp(2,1,2,2) = qedamp(1,2,1,1)
      qedamp(2,2,1,1) = qedamp(1,1,2,2)
      qedamp(2,2,1,2) = qedamp(1,1,2,1)
      qedamp(2,2,2,1) = qedamp(1,1,1,2)
      qedamp(2,2,2,2) = qedamp(1,1,1,1)

         sum = 0
         do i = 1,2
          do j = 1,2
      if (iha.eq.1) then
         ii = 1
         jj = 1
         sum=0
       endif
      if  (iha.eq.2) then
         ii = 1
         jj = 2
         sum=0
      endif
      if (iha.eq.0) then
         ii=i
         jj=j
      endif
               do k = 1,2
                  do l = 1,2
                     if (iew.eq.1) then
         sum=sum+ewcoeff**2*ewamp(ii,jj,k,l)*qconjg(ewamp(ii,jj,k,l))
                     endif
                     if (iqed.eq.1) then
         sum=sum+qedcoeff**2*qedamp(ii,jj,k,l)*qconjg(qedamp(ii,jj,k,l))
                     endif
                     if ((iew.eq.1).and.(iqed.eq.1)) then
         sum=sum + qedcoeff*ewcoeff*(
     &                      qconjg(ewamp(ii,jj,k,l))*qedamp(ii,jj,k,l)
     &                     +ewamp(ii,jj,k,l)*qconjg(qedamp(ii,jj,k,l)) )
                     endif
                  enddo
               enddo
            enddo
         enddo
      if (iha.eq.0) then
      sigma = nsig*sum
      else
      sigma = 2q0*nsig*sum
      endif
      return
      end
