      SUBROUTINE SIMPSD(A1,B1,H1,REPS1,AEPS1,FUNCT,X,AI,AIH,AIABS)
C SIMPS WITH REAL*16
C A1,B1 -THE LIMITS OF INTEGRATION
C H1 -AN INITIAL STEP OF INTEGRATION
C REPS1,AEPS1 - RELATIVE AND ABSOLUTE PRECISION OF INTEGRATION
C FUNCT -A NAME OF FUNCTION SUBPROGRAM FOR CALCULATION OF INTEGRAND +
C X - AN ARGUMENT OF THE INTEGRAND
C AI - THE VALUE OF INTEGRAL
C AIH- THE VALUE OF INTEGRAL WITH THE STEP OF INTEGRATION
C AIABS- THE VALUE OF INTEGRAL FOR MODULE OF THE INTEGRAND
C THIS SUBROGRAM CALCULATES THE DEFINITE INTEGRAL WITH THE RELATIVE OR
C ABSOLUTE PRECISION BY SIMPSON+S METHOD WITH THE AUTOMATICAL CHOICE
C OF THE STEP OF INTEGRATION
C IF AEPS1    IS VERY SMALL(LIKE 1.E-17),THEN CALCULATION OF INTEGRAL
C WITH REPS1,AND IF REPS1 IS VERY SMALL (LIKE 1.E-10),THEN CALCULATION
C OF INTEGRAL WITH AEPS1
C WHEN AEPS1=REPS1=0. THEN CALCULATION WITH THE CONSTANT STEP H1
C
      IMPLICIT REAL*16(A-H,O-Z)
      DIMENSION F(7),P(5)
      EXTERNAL FUNCT
*
      H=QSIGN(H1,B1-A1)
      S=QSIGN(1.Q0,H)
      A=A1
      B=B1
      AI=0.Q0
      AIH=0.Q0
      AIABS=0.Q0
      P(2)=4.Q0
      P(4)=4.Q0
      P(3)=2.Q0
      P(5)=1.Q0
      IF(B-A) 1,2,1
    1 REPS=QABS(REPS1)
      AEPS=QABS(AEPS1)
      DO 3 K=1,7
  3   F(K)=10.Q16
      X=A
      C=0.Q0
      F(1)=FUNCT(X)/3.Q0
    4 X0=X
      IF((X0+4.Q0*H-B)*S) 5,5,6
    6 H=(B-X0)/4.Q0
      IF(H) 7,2,7
    7 DO 8 K=2,7
  8   F(K)=10.Q16
      C=1.Q0
    5 DI2=F(1)
      DI3=QABS(F(1))
      DO 9 K=2,5
      X=X+H
      IF((X-B)*S) 23,24,24
   24 X=B
   23 IF(F(K)-10.Q16) 10,11,10
   11 F(K)=FUNCT(X)/3.Q0
   10 DI2=DI2+P(K)*F(K)
    9 DI3=DI3+P(K)*ABS(F(K))
      DI1=(F(1)+4.Q0*F(3)+F(5))*2.Q0*H
      DI2=DI2*H
      DI3=DI3*H
      IF(REPS) 12,13,12
   13 IF(AEPS) 12,14,12
   12 EPS=QABS((AIABS+DI3)*REPS)
      IF(EPS-AEPS) 15,16,16
   15 EPS=AEPS
   16 DELTA=QABS(DI2-DI1)
      IF(DELTA-EPS) 20,21,21
   20 IF(DELTA-EPS/8.Q0) 17,14,14
   17 H=2.Q0*H
      F(1)=F(5)
      F(2)=F(6)
      F(3)=F(7)
      DO 19 K=4,7
  19  F(K)=10.Q16
      GO TO 18
   14 F(1)=F(5)
      F(3)=F(6)
      F(5)=F(7)
      F(2)=10.Q16
      F(4)=10.Q16
      F(6)=10.Q16
      F(7)=10.Q16
   18 DI1=DI2+(DI2-DI1)/15.Q0
      AI=AI+DI1
      AIH=AIH+DI2
      AIABS=AIABS+DI3
      GO TO 22
   21 H=H/2.Q0
      F(7)=F(5)
      F(6)=F(4)
      F(5)=F(3)
      F(3)=F(2)
      F(2)=10.Q16
      F(4)=10.Q16
      X=X0
      C=0.Q0
      GO TO 5
   22 IF(C) 2,4,2
    2 RETURN
      END
