      COMPLEX*32 FUNCTION XSPENZ(X)
      implicit none!
*     ---------------
* Hans Kuijf, 1988
* XSPENZ(X) calcs the complex spence-function, through mapping on
* the area where there is a quickly convergent series.
      integer*4 debug
      REAL*16 PI
      COMPLEX*32 X,CSPENQ
      debug = 0
      PI=4Q0*QATAN(1Q0)
* Map the x on the unit circle.
* But so that x is not in the neighbourhood of (1,0)
* ABS(Z)=-CDLOG(1D0-X) is always smaller than 1.10
* But (1.10)^19/(19!)*bernoulli(19)=2.7D-15
      IF (CQABS(1Q0-X).LT.1Q-15) THEN
         XSPENZ=PI*PI/6Q0
         if (debug.eq.1) then
            print *, "xszq",1
         endif
      ELSE IF (CQABS(1Q0-X).LT.0.5Q0) THEN
         XSPENZ=PI*PI/6Q0-CQLOG(1Q0-X)*CQLOG(X)-CSPENQ(1Q0-X)
*        print *, "clog1x", CQLOG(1Q0-X)
*        print *, "clog x", CQLOG(X)
         if (debug.eq.1) then
            print *, "xszq",2
         endif
      ELSE IF (CQABS(X).GT.1Q0) THEN
         XSPENZ=-PI*PI/6Q0-0.5Q0*CQLOG(-X)*CQLOG(-X)-CSPENQ(1Q0/X)
         if (debug.eq.1) then
            print *, "xszq",3
         endif
      ELSE
         XSPENZ = CSPENQ(X)
         if (debug.eq.1) then
            print *, "xszq",4
         endif
      END IF
      END
* 
      FUNCTION CSPENQ(Z)
      implicit none             !
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     SPENCE-FUNKTION KOMPLEX, FREI NACH HOLLIK                       C
C---------------------------------------------------------------------C
C     20.07.83    UE 20.08.85                                         C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      integer*4 ii,K
      COMPLEX*32 CSPENQ,W,SUM,Z,U
      REAL*16 RZ,AZ,A1,B(25),PI,PI23,PI26
C     BEACHTE:                 B(N)=B2N
      B(1)  =                                 1Q0 /        6Q0
      B(2)  =                                -1Q0 /       30Q0
      B(3)  =                                 1Q0 /       42Q0
      B(4)  =                                -1Q0 /       30Q0
      B(5)  =                                 5Q0 /       66Q0
      B(6)  =                              -691Q0 /     2730Q0
      B(7)  =                                 7Q0 /        6Q0
      B(8)  =                             -3617Q0 /      510Q0
      B(9)  =                             43867Q0 /      798Q0
      B(10) =                          -1 74611Q0 /      330Q0
      B(11) =                           8 54513Q0 /      138Q0
      B(12) =                       -2363 64091Q0 /     2730Q0
      B(13) =                          85 53103Q0 /        6Q0
      B(14) =                    -2 37494 61029Q0 /      870Q0
      B(15) =                   861 58412 76005Q0 /    14322Q0
      B(16) =                  -770 93210 41217Q0 /      510Q0
      B(17) =                   257 76878 58367Q0 /        6Q0
      B(18) =          -26315 27155 30534 77373Q0 / 19 19190Q0
      B(19) =               2 92999 39138 41559Q0 /        6Q0
      B(20) =        -2 61082 71849 64491 22051Q0 /    13530Q0
      B(21) =        15 20097 64391 80708 02691Q0 /     1806Q0
      B(22) =      -278 33269 57930 10242 35023Q0 /      690Q0 
      B(23) =      5964 51111 59391 21632 77961Q0 /      282Q0
      B(24) =-560 94033 68997 81768 62491 27547Q0 /    46410Q0
      B(25) =  49 50572 05241 07964 82124 77525Q0 /       66Q0
      
*     PI=3.1415926535897932384
C     PI*PI/6.=1.6449..., PI*PI/3=3.28986...
      PI   = 4Q0*QATAN(1Q0)
      PI26 = PI**2/6Q0
      PI23 = PI**2/3Q0
C
C---> GENAUIGKEIT
      II = 25
      RZ=QREAL(Z)
      AZ=CQABS(Z)
      A1=CQABS(1Q0-Z)
*      print *, "z", z
      IF((QABS(RZ-1Q0).LE.1Q-20).AND.(QABS(QIMAG(Z)).LE.1Q-20))GOTO 40
      IF(RZ.GT.5Q-1) GOTO 20
      IF(AZ.GT.1Q0) GOTO 10
*      print *, "full"
      W=-CQLOG(1Q0-Z)
*      print *, "W", W
      SUM=W-0.25Q0*W*W
      U=W
      DO 1 K=1,II
      U=U*W*W/QFLOAT(2*K*(2*K+1))
      SUM=SUM+U*B(K)
 1    CONTINUE
      CSPENQ=SUM
*      print *, "sum",sum
      RETURN
10    W=-CQLOG(1Q0-1Q0/Z)
      SUM=W-0.25Q0*W*W
      U=W
      DO 11 K=1,II
      U=U*W*W/QFLOAT(2*K*(2*K+1))
      SUM=SUM+U*B(K)
11    CONTINUE
      CSPENQ=-SUM-PI26-.5Q0*CQLOG(-Z)**2
      RETURN
20    IF(A1.GT.1Q0) GOTO 30
*     print *, "20"
      W=-CQLOG(Z)
      SUM=W-0.25Q0*W*W
      U=W
      DO 21 K=1,II
      U=U*W*W/QFLOAT(2*K*(2*K+1))
      SUM=SUM+U*B(K)
21    CONTINUE
      CSPENQ=-SUM+PI26-CQLOG(Z)*CQLOG(1Q0-Z)
      RETURN
30    W=CQLOG(1Q0-1Q0/Z)
      SUM=W-0.25Q0*W*W
      U=W
      DO 31 K=1,II
      U=U*W*W/QFLOAT(2*K*(2*K+1))
      SUM=SUM+U*B(K)
31    CONTINUE
      CSPENQ=SUM+PI23+.5Q0*CQLOG(Z-1Q0)**2-CQLOG(Z)*CQLOG(1Q0-Z)
50    CONTINUE
      RETURN
40    CSPENQ=QCMPLX(PI26,0Q0)
      RETURN
      END
